addhook("movetile","tilecheck")
addhook("startround","bush_roundstart")
addhook("join","bush_join")
addhook("second","bush_second")
addhook("hit","bush_hit")

parse("restart")

bush = {}

bush.tileVar = {}
bush.tileVarb = {}
bush.tileVarc = {}
bush.tileVard = {}

usr = {}

function bush_join(id)
	usr[id] = {}
	usr[id].soundcd = true
	usr[id].armorval = 0
	usr[id].inbush = false
end

function bush_second()
	for _,id in pairs(player(0,"table")) do
		if ( usr[id].armorval == 204 ) and ( usr[id].inbush == true ) then
			parse("sethealth "..id.." "..player(id,"health") + 5 )
		end
		usr[id].soundcd = true
	end
end


function tilecheck(id,x,y)
	stealth(id,x,y)
end

function stealth(id,x,y)
	if entity(x,y,"name") == "bush" then
		if player(id,"armor") ~= 206 then
			usr[id].armorval = player(id,"armor")
			usr[id].inbush = true
			parse("setarmor "..id.." 206")
		end
		for _,idnr in pairs(player(0,"table")) do
			if DistanceBetweenPlayers(idnr,id) < 320 then
				if usr[idnr].soundcd == true then
					parse("sv_sound2 "..idnr.." \"entity05/bushwalk.wav\"")
					usr[idnr].soundcd = false
				end
			end
		end
	elseif usr[id].inbush == true then
		parse("setarmor "..id.." "..usr[id].armorval)
		usr[id].inbush = false
	end
end

function bush_roundstart()
	for x = 0, map'xsize' do
	
		bush.tileVar[x] = {}
		bush.tileVarb[x] = {}
		bush.tileVarc[x] = {}
		bush.tileVard[x] = {}
		
		for y = 0, map'ysize' do
		
			bush.tileVar[x][y] = {}
			bush.tileVarb[x][y] = {}
			bush.tileVarc[x][y] = {}
			bush.tileVard[x][y] = {}
			
			if entity(x,y,"name") == "bush" then
				
				local rotat = math.random(0,359)
				
				bush.tileVar[x][y]=image("gfx/entity05/1.bmp",x * 32 + 16,y * 32 + 16,1)
				imagescale(bush.tileVar[x][y],0.5,0.5)
				imagealpha(bush.tileVar[x][y],0.5)
				tween_rotate(bush.tileVar[x][y],1,rotat)
				
				bush.tileVarb[x][y]=image("gfx/entity05/2.bmp",x * 32 + 16,y * 32 + 16,1)
				imagescale(bush.tileVarb[x][y],0.5,0.5)
				imagealpha(bush.tileVarb[x][y],0.7)
				tween_rotate(bush.tileVarb[x][y],1,rotat)
				
				bush.tileVarc[x][y]=image("gfx/entity05/3.bmp",x * 32 + 16,y * 32 + 16,1)
				imagescale(bush.tileVarc[x][y],0.5,0.5)
				imagealpha(bush.tileVarc[x][y],0.2)
				tween_rotate(bush.tileVarc[x][y],1,rotat)
				
				bush.tileVard[x][y]=image("gfx/entity05/shade.bmp",x * 32 + 16,y * 32 + 16,0)
				imagescale(bush.tileVard[x][y],0.5,0.5)
				imagealpha(bush.tileVard[x][y],0.5)
				
			end
		end
	end
end

function bush_hit(id,attid,wep,hpdmg,apdmg,rawdmg)
	if usr[id].inbush == true then
		if ( usr[id].armorval > 0 ) and ( usr[id].armorval <= 200 ) then 
			if usr[id].armorval < rawdmg then
				local dmgout = math.floor( rawdmg - usr[id].armorval )
				if dmgout < player(id,"health") then
					parse("sethealth "..id.." "..player(id,"health") - dmgout )
				else
					parse("setarmor "..id.." 0")
					parse("customkill "..attid.." "..item(wep,"name").." "..id)
				end
				usr[id].armorval = 0
			else
				usr[id].armorval = usr[id].armorval - rawdmg
			end
		elseif usr[id].armorval == 201 then -- Light Armor 25%
			local dmgout = math.floor( rawdmg / 4 * 3 )
			if dmgout < player(id,"health") then
				parse("sethealth "..id.." "..player(id,"health") - dmgout )
			else
				parse("setarmor "..id.." 0")
				parse("customkill "..attid.." "..item(wep,"name").." "..id)
			end
		elseif ( usr[id].armorval == 202 ) or ( usr[id].armorval == 204 ) then -- Armor / Medic Armor 50%
			local dmgout = math.floor( rawdmg / 2 )
			if dmgout < player(id,"health") then
				parse("sethealth "..id.." "..player(id,"health") - dmgout )
			else
				parse("setarmor "..id.." 0")
				parse("customkill "..attid.." "..item(wep,"name").." "..id)
			end
		elseif usr[id].armorval == 203 then -- Heavy Armor 75%
			local dmgout = math.floor( rawdmg / 4 )
			if dmgout < player(id,"health") then
				parse("sethealth "..id.." "..player(id,"health") - dmgout )
			else
				parse("setarmor "..id.." 0")
				parse("customkill "..attid.." "..item(wep,"name").." "..id)
			end
		elseif usr[id].armorval == 205 then -- Super Armor 95%
			local dmgout =  math.floor( rawdmg / 20 )
			if dmgout < player(id,"health") then
				parse("sethealth "..id.." "..player(id,"health") - dmgout )
			else
				parse("setarmor "..id.." 0")
				parse("customkill "..attid.." "..item(wep,"name").." "..id)
			end
		else
			if rawdmg < player(id,"health") then
				parse("sethealth "..id.." "..player(id,"health") - rawdmg )
			else
				parse("setarmor "..id.." 0")
				parse("customkill "..attid.." "..item(wep,"name").." "..id)
			end
		end
		return 1
	end
end





-- Rainoth --
function DistanceBetweenPlayers(idA,idB)
	if (idA ~= 0 and idB ~= 0 and player(idA, "exists") and player(idB, "exists")) then
		distance = math.sqrt(math.pow(((player(idA,"x")-player(idB,"x"))),2)+math.pow(((player(idA,"y")-player(idB,"y"))),2))
		return distance
	end
end
-------------